# Changelog

All notable changes to this project will be documented in this file.

## [0.2.4] - 2023-09-14
- Package update

## [0.2.3] - 2023-08-31
- Revert Fields JS version

## [0.2.2] - 2023-08-31
- Page Loader Emit event when removed
- Update Fields JS version

## [0.2.1] - 2023-08-31
- Update/Fixes Cdn Loaders

## [0.2.0] - 2023-08-31
- Update Cdn Loaders

## [0.1.9] - 2023-08-27
- Add system macro
- Add commons macro
- Fix util

## [0.1.8] - 2023-08-18
- Update Video Block CDN

## [0.1.7] - 2023-07-20
- Fix Swiper JS Fragments

## [0.1.6] - 2023-07-20
- Fix Swiper JS Fragments

## [0.1.5] - 2023-07-20
- Fix Swiper JS Fragments

## [0.1.4] - 2023-07-18
- Prototypes
- CDN Loaders
	- Update VueMask Loader

## [0.1.3] - 2023-07-18
- Page Loader
	- Method to perform multiple axios calls and then remove page loader if in use
- CDN Loaders
	- Vuei18n Loader
	- Luxon Loader

## [0.1.2] - 2023-06-29
- VueLoader, can load v2 or 3
	- Version should only be used if there are no vue tags within the root component on load.
	- Vue Router Load for Vue 2 or 3
	- Can simply run `VueLoader.loadVueScripts({ vueVersion: 3, includeRouter : true })`
- Create Nav From Heading Helper 

## [0.1.1] - 2022-10-26
- Small JS and testimonial update

## [0.1.0] - 2022-10-26

- Updates to Init Function (See Notes Below)
```javascript
// Dev Helper Setup
(require('hs-dev-helper/init')({
	enablePackageFields : true,
	globalFieldsDir: 'src/fields/lib',
	enablePackageConfig : true,
	configSrcFile : 'src/fields/config.js',
	configHublAccessKey: undefined, // Default to 'toHubl"
	configHublKey: undefined, // Default to $hublConfig
	configToHublVariableDest : 'src/hubl/vars/config.html',
	generateHublConfig: true
}));
```
- Fields Library removed. `loadFromFieldsDir` instead
- Config to Sass Generator
```javascript
// in your config file
toSass: {
	variableName: 'foobar'
}

// in your node init file
const { generateSassVariablesFromConfig } = require('hs-dev-helper/build/configToSass');
let sassAdditionalData = generateSassVariablesFromConfig('toSass')

// add to your sass loader
additionalData: sassAdditionalData || "",

// in your sass file
color: $variableName;
```
- Page Loader
```html
<!-- In your HUBL layout -->
{% import "./macros/page-loader.html" %}
<body>
	{ % call pageLoader({ class : "bg-black", waitMs : 20 }) % }
		{% include "../partials/logo.html" ignore missing %}
	{ % endcall % }
```
``` javascript
//In JS:
import removePageLoader from 'hs-dev-helper/js-toolkit/removePageLoader';
removePageLoader()
```
- Component Updates
	- Macros
	- Dict `deepUpdate` macro
	- Twitter and Vue CDN Loaders
	- Body "loaded" Class methods
	- Vue ScrollTop component
	- Style updates

**NOTES:**
- `configHublAccessKey` is used to identify the key within your config file that is used to generate the HUBL code
- `configHublKey` is the variable name that you can access the hubl dict with eg. `{{ $hublConfig.foo }}`
- The configHubl is also set in a node global variable.


## [0.0.3] - 2022-10-16
- Init Helper Function
```javascript
// Dev Helper Setup
(require('hs-dev-helper/init')({
	enablePackageFields : true,
	enablePackageConfig : true,
	enablePackageLibrary : true,
	globalFieldsDir: 'src/fields/lib',
	fieldsConfigSrcFile : 'src/fields/config.js',
	fieldsLibrarySrcFile : 'src/fields/library.js',
	configToHublDest : 'src/hubl/vars/config.html',
	generateHublConfig: true,
}));
```

## [0.0.2] - 2022-10-16
- Cdn Loaders

## [0.0.1] - 2022-10-15
- Initial Publish
