//Hubl Config will take the config file and convert it to a hubL file
/**
	const {
		setHublConfigDest,
		setHublConfigKey,
		generateHublFromConfig
	} = require('hs-dev-helper/build/configToHublVariable');

	setHublConfigDest(path.join(__dirname, 'src/hubl/vars/config.html'))
	setHublConfigKey('myVar')
	generateHublFromConfig();

	NOTE: you will need to restart your node process to regenerate the Config data

	-------

	Include the file at the top of your template
	{% import "./vars/config.html" %}
	
	-------
	
	Add Macro to add window variable
	{{ configToScript() }}
	Access in frontend JS by window.myVar

*/

const fs = require('fs');
const path = require('path'); 
const { getConfig } = require('./configSetup');

let hublConfigKey = '$hublConfig'
const setHublConfigKey = (variable) => {
	hublConfigKey = variable
	return hublConfigKey
}

const getHublConfigKey = () => hublConfigKey

const getHublConfigData = (accessKey = 'toHubl') => { 
	let configData = getConfig();
	if (!configData[accessKey]) { return {}; }
	return configData[accessKey] || {};
}

/**
 * Set Desctination path where the partial will be created
 */
let hublConfigDest = null
const setHublConfigDest = (path) => {
	hublConfigDest = path
	return hublConfigDest
}

const generateHublFromConfig = (accessKey = 'toHubl') => { 
	if (!hublConfigKey || !hublConfigDest) { return null }
	// Get Data
	let configData = getHublConfigData(accessKey);
	let data = `{# Automatically Generated #}\n`
	data += `{% set ${hublConfigKey} = ('${JSON.stringify(configData)}')|fromjson %}`
	data += `\n\n{% macro configToScript() -%}<script type="text/javascript">window.${hublConfigKey} = JSON.parse('{{ ${hublConfigKey}|tojson|escapejson }}');</script>{%- endmacro %}`
	
	// Write
	fs.writeFileSync(path.resolve(hublConfigDest), data);
}

/**
 * Exports
 */
module.exports = {
	setHublConfigDest,
	generateHublFromConfig,
	getHublConfigData,
	setHublConfigKey,
	getHublConfigKey
}