const { deepExtend } = require('../js-toolkit/util/obj');

/**
 * Config
 */
let configSrc = null
const setConfigSrc = (path) => {
	configSrc = path
	return configSrc
}

let usePackageConfig = true
const setEnablePackageConfig = (val) => {
	usePackageConfig = !!val
	return usePackageConfig
}

const getConfig = () => {
	// Get Package Config
	let packageConfig = usePackageConfig ? require('./config.default') : {}
	if (!configSrc) { return packageConfig }
	// Merge in Custom Config
	delete require.cache[require.resolve(configSrc)];
	let customConfig = require(configSrc);
	return deepExtend(packageConfig,customConfig)
}

const getFromConfig = (key, defaultValue) => {
	if (!configSrc) { 
		throw new Error('Fields Config Source Path not set. Use setConfigSrc(path)')
	}
	let configVars = getConfig()
	try {
		if(configVars[key] != undefined) { return configVars[key]; }
		if (defaultValue != 'undefined') { return defaultValue }
		throw new Error('No configuration option found for key: ' + key);
	} catch(e) {
		logger.error('Could not read configuration item:\n' + e);
		throw e
	}
}


/**
 * Exports
 */
module.exports = {
	setConfigSrc,
	setEnablePackageConfig,
	getConfig,
	config: getFromConfig
};