
/**
	// in your config file
	toSass: {
		variableName: 'foobar'
	}
	
	// in your node init file
	const { generateSassVariablesFromConfig } = require('hs-dev-helper/build/configToSass');
	let sassAdditionalData = generateSassVariablesFromConfig('toSass')
	
	// add to your sass loader
	additionalData: sassAdditionalData || "",

	// in your sass file 
	color: $variableName;

	// use sass:map if you are including objects
	@use "sass:map";
	map.get($data, weights, regular)
 */

const { getConfig } = require('./configSetup');

const generateSassVariablesFromConfig = (accessKey = 'toSass') => {
	if (!accessKey) { return; }
	
	// Get Config Data
	let configData = getConfig();
	if (!configData[accessKey]) { return; }
	configData = configData[accessKey] || {}
	// Check
	if (typeof configData !== 'object' || Array.isArray(configData)) {
		return;
	}

	let out = '';
	Object.entries(configData).forEach(e => { 
		let [key, value] = e
		value = JSON.stringify(value).replaceAll('{', '(').replaceAll('}', ')')
		out += `$${key}: ${value};`
	})

	return out
}

/**
 * Exports
 */
module.exports = {
	generateSassVariablesFromConfig
}