const { Field } = require('../../build');

module.exports = class extends Field {
	
	constructor() {
		super()
		this.set('type',Field.choice().data.type)
			.name('columns', 'Columns')
			.choices([
				["1", "1 Column"],
				["2", "2 Columns"],
				["3", "3 Columns"],
				["4", "4 Columns"]
			])
			.default('3')
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		this.applyIf(!!this._modifyChoices, (field) => field.choices(this._modifyChoices(this.data.choices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

	_modifyChoices = false
	modifyChoices(fn) { 
		this._modifyChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}