const { Field } = require('../../build');

module.exports = class extends Field {
	
	constructor() {
		super()
		this.set('type',Field.choice().data.type)
			.name('flex_direction', 'Layout Direction')
			.choices([
				["flex-row", "Side by Side"],
				["flex-column", "Stacked"]
			])
			.inlineHelpText('How the content areas will be laid out.')
			.default('flex-row')
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}