const { Field } = require('../../build');

module.exports = class extends Field {
	
	constructor() {
		super()
		this.set('type',Field.choice().data.type)
			.name('justify_content', 'Justify Content')
			.inlineHelpText('Align the content areas within the module.')
			.choices([
				['start', 'Top/Start'],
				['center', 'Middle'],
				['end', 'Bottom/ End'],
				['around', 'Spaced Evenly'],
				['between', 'Spread Out'],
			])
			.default('center')
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}