const path = require('path');

// Config
const {
	setConfigSrc,
	setEnablePackageConfig
} = require('./build/configSetup');

// Hubl Config
const {
	setHublConfigKey,
	getHublConfigKey,
	getHublConfigData,
	setHublConfigDest,
	generateHublFromConfig
} = require('./build/configHubl');

// Field Library
const {
	setGlobalFieldsDirPath,
	setEnablePackageFields
} = require('./fieldsJs');

module.exports = (data = {}) => {
	data = data || {}
	data = Object.assign({
		enablePackageFields : true,
		globalFieldsDir: null,
		enablePackageConfig : true,
		configSrcFile: null,
		configHublAccessKey: undefined,
		configHublKey: undefined,
		configHublVariableDest: null,
		generateHublConfig: true,
	}, data)

	let {
		enablePackageFields,
		globalFieldsDir,
		enablePackageConfig,
		configSrcFile,
		configHublAccessKey,
		configHublKey,
		configHublVariableDest,
		generateHublConfig
	} = data

	// Enable
	setEnablePackageFields(!!enablePackageFields);
	setEnablePackageConfig(!!enablePackageConfig);

	// Set Global Fields Dir
	if (!!globalFieldsDir) {
		setGlobalFieldsDirPath(path.join(process.env.INIT_CWD, globalFieldsDir))
	}
	// Set Field Config JS Src File
	if (!!configSrcFile) {
		setConfigSrc(path.join(process.env.INIT_CWD, configSrcFile))
	}
	if (!!configHublKey) { 
		setHublConfigKey(configHublKey);
	}

	// HublConfig - Add to Node Global	
	global[getHublConfigKey()] = getHublConfigData();

	// Set Config to Hubl destination 
	if (!!configHublVariableDest) {
		setHublConfigDest(path.join(process.env.INIT_CWD, configHublVariableDest))
		if (!!generateHublConfig) { 
			generateHublFromConfig(configHublAccessKey);
		}
	}

	return data
};