export default (function(){
    return {
        debug: false,
        containers: [],

        init: function(selector){
            let [els] = this.containers[selector] || [];

            els.forEach((item)=>{
                const observer = new IntersectionObserver(function (entries) {
                    if (entries[0].isIntersecting === true) {
                        observer.unobserve(item);
                        this.duration = 2000;
                        this.frameDuration = 1000 / 60;

                        this.totalFrames = Math.round(this.duration / this.frameDuration);
                        this.easeOutQuad = t => t * (2 - t);

                        let frame = 0;
                        const countTo = parseInt(item.innerHTML, 10);

                        const counter = setInterval(() => {
                            frame++;
                            const progress = this.easeOutQuad(frame / this.totalFrames);
                            const currentCount = Math.round(countTo * progress);
                            if (parseInt(item.innerHTML, 10) !== currentCount) {
                                item.innerHTML = currentCount;
                            }
                            if (frame === this.totalFrames) {
                                clearInterval(counter);
                            }
                        }, this.frameDuration);
                    }
                }, { threshold: [0.2] });
                observer.observe(item);
            });
        },

        initIfExists: function(selector){
            let els = document.querySelectorAll(selector) || [];

            if (els.length) {
                this.containers[selector] = [els];
                //Init Animation Observer
                 this.init(selector);
            }
            else {
                this.log(`Container with selector ${selector} not found!`);
            }
		},
		
		log: function(...args){
            if (this.debug) {
                console.log(args);
            } 
        },
    }
})();