
const { sleep } = require('../util/request')

const removePageLoader = () => {
	return new Promise(async (res,rej) => {
		// Remove Page Loader
		let pageLoader = document.getElementById('page-loader')
		if (pageLoader) {
			let waitTime = parseInt(pageLoader.getAttribute('data-wait-ms')) || 0
			if (waitTime) { await sleep(waitTime) }
			pageLoader.classList.remove('loading')
			window.dispatchEvent(new CustomEvent('PageLoaderRemoved'));
		}
		res();
	})
};

const loadScripts = async ({ promises =[], callback = null } = {}) => {
	return Promise.all(promises)
		.then(async () => {
			removePageLoader();
			if (typeof callback == 'function') {
				callback()
			}
		});
};

module.exports = {
	removePageLoader,
	loadScripts
}