export const fileToBlob = (file) => {
	if (!(file instanceof File)) { return; }
	return new Promise((res, rej) => {
		let reader = new FileReader();
		reader.readAsDataURL(file);
		reader.onload = function () {
			return res(reader.result);
		};
		reader.onerror = function (error) {
			return rej(error);
		};
	})
};

export const addNameToFile = async (file, name) => {
	if (!name) { return; }
	return new Promise(async (resolve, reject) => {
		let result = await fileToBlob(file)
		resolve(new File([result], name));
	})
};